local mod = ...



-- Assets -------------------------------------------------------------------------------------
mod:registerAssetId("models/CattleHerd1.fbx/Prefab/HutPart", "PREFAB_CATTLEHERD_HUT")
-- mod:registerAssetId("models/CattleHerd1.fbx/Prefab/WaterPart", "PREFAB_MINERAL_WATER")



-- Grounding -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/CattleHerd1.fbx/Prefab/HutPart/Barrel.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/CattleHerd1.fbx/Prefab/HutPart/Barrel.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/CattleHerd1.fbx/Prefab/HutPart/Bucket.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/CattleHerd1.fbx/Prefab/HutPart/Bench.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/CattleHerd1.fbx/Prefab/HutPart/Jug.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/CattleHerd1.fbx/Prefab/HutPart/Thatch.001", {DataType = "COMP_GROUNDED"})



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/CattleHerd1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Building: Cattle Herd -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_CATTLEHERD",
	Name = "BUILDING_CATTLEHERD_NAME",
	Description = "BUILDING_CATTLEHERD_DESC",
	BuildingType = "GENERAL",
	AssetCoreBuildingPart = "BUILDING_PART_CATTLEHERD_HUT",
	VillagerRequired = { Status = "SERF", Quantity = 8 }
})



-- Building Part: Cattle Herd Hut -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_CATTLEHERD_HUT",
	Name = "BUILDING_PART_CATTLEHERD_HUT_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_CATTLEHERD_HUT"
	},
	BuildingZone = { 
		ZoneEntryList = {
			{ 
				Polygon = polygon.createCircle( 2.1, {0, 0}, 16 ),
				Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_CATTLE_MILK",
	Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
		}
	}
})



-- Job: Cattle Herder -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_CATTLEHERD",
	JobName = "JOB_CATTLEHERD_NAME",
	JobDescription = "JOB_CATTLEHERD_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_GATHER",
    ProductionDelay = 20.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
		RightHandObject = {
			DataType = "HAND_OBJECT",
			Model = "PREFAB_TOOL_SHEPHERD_STICK"
		},
		IdleAnimation = "GUARD"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_CATTLEHERD"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_CATTLEHERD"
    }
})



-- Building Function: Milk Cows -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_CATTLE_MILK",
    Name = "BUILDING_FUNCTION_CATTLE_MILK_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_CATTLEHERD", 
        Behavior = "BEHAVIOR_GATHER"
    },
    InputInventoryCapacity = {
		{ Resource = "MILK", Quantity = 1 }, 
	},
    ResourceListNeeded = {
		{ Resource = "MILK", Quantity = 1 }, 
	},
	ResourceProduced = {
        { Resource = "MILK", Quantity = 1 },
    }
})



-- Resource: Milk (override) -------------------------------------------------------------------------------------
mod:override({
	Id = "MILK",
	IsTradable = true,
	ResourceLayoutType = "CRATES",
	ResourceTypeList = { "RESOURCE_FOOD", "FOOD" },
	VillagerBuyingPrice = { Resource = "GOLD", Quantity = 6 },
	DisplayInInventory = true
})



