local mod = ...


mod:override({
    Id = "DEFAULT_BALANCING",
    StartingTileResourceRequirement = {
        {
            Resource = "BERRIES",
            Quantity = 1
        },
        {
            Resource = "STONE",
            Quantity = 1
        },
        {
            Resource = "WOOD",
            Quantity = 5
        },
    }
})



-- -- Assets -------------------------------------------------------------------------------------
-- mod:registerAssetId("models/CattleHerd1.fbx/Prefab/TreePart1/Tree.001", "PREFAB_STEPPE_TREE1")



-- -- Plantable -------------------------------------------------------------------------------------
-- mod:registerPrefabComponent("models/CattleHerd1.fbx/Prefab/TreePart1/Tree.001", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 5.0 })
-- mod:registerPrefabComponent("models/CattleHerd1.fbx/Prefab/TreePart1/Tree.001", { DataType = "COMP_TREE" })

-- mod:register({
--     DataType = "PLANTABLE",
--     Id = "PLANTABLE_STEPPE_TREE1",
--     Name = "PLANTABLE_STEPPE_TREE1_NAME",
--     PlantPrefab = "PREFAB_STEPPE_TREE1",
--     MinimumScale = 0.85, -- min size at full growth
--     MaximumScale = 1.15 -- max size at full growth
-- })



-- -- Resource Container -------------------------------------------------------------------------------------
-- mod:registerPrefabComponent( "models/CattleHerd1.fbx/Prefab/TreePart1/Tree.001", {
--     DataType = "COMP_RESOURCE_CONTAINER",
--     ResourceData = "WOOD",
--     IsReplenishable = false,
--     ResourceValue = 1.0, -- how many are gathered with each pick
--     AvailableQuantity = 1, -- maximum container stock
--     Radius = 0.85, -- distance from container that the villager will stand to pick
--     IsDestroyWhenEmpty = true,
--     HasMaximumWorkstation = false
-- })



-- registering map files
mod:registerAssetId("maps/heightmap.png", "HEIGHT_MAP")
mod:registerAssetId("maps/material_mask.png", "MATERIAL_MASK")
mod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mod:registerAssetId("maps/iron_density.png", "IRON_DENSITY_MAP")
mod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")
mod:registerAssetId("maps/tree_density_map1.png", "TREE_DENSITY_MAP1")
mod:registerAssetId("maps/tree_density_map2.png", "TREE_DENSITY_MAP2")
mod:registerAssetId("maps/tree_density_map3.png", "TREE_DENSITY_MAP3")
mod:registerAssetId("maps/milk.png", "MILK_DENSITY_MAP")

-- register custom map
mod:register({
	DataType = "CUSTOM_MAP",
	Id = "COURSONVIL_ID",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -22,
	MaxHeight = 78,
	VillagePathList = {
		{
			Entrance = { 899, 0, 1018 },
			Exit = { 532, 0, 1018 },
		},
		{
			Entrance = { 346, 0, 1018 },
			Exit = { 789, 0, 1 },
		},
		{
			Entrance = { 1019, 0, 752 },
			Exit = { 1016, 0, 1 },
		}
	},
	SpawnList = {
		{
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 342 , 65 , 490 },
			Orientation = { 0.0, -0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 2
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 176 , 7 , 767 },
			Orientation = { 0.0, -0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 405 , 8 , 680 },
			Orientation = { 0.0, -0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 4
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 280 , 10 , 105 },
			Orientation = { 0.0, -0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 5
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 928 , 10 , 613 },
			Orientation = { 0.0, -0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 6
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 614 , 5 , 880 },
			Orientation = { 0.0, -0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 7
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 947 , 5 , 452 },
			Orientation = { 0.0, -0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		}
	},
	DensitySpawnList = {
			{
			-- creating Tree Density Map1
			DensityMap = "TREE_DENSITY_MAP1",
			Density = 0.31,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_OAK" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				}
			}
		},
			{
			-- creating Tree Density Map2
			DensityMap = "TREE_DENSITY_MAP2",
			Density = 0.31,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.2,0.4,0.2,1 },
							Max = { 0.4,0.8,0.4,1 }
					}
				}
			}
		},
			{
			-- creating Tree Density Map3
			DensityMap = "TREE_DENSITY_MAP3",
			Density = 0.31,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_OAK" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1,1,1,1 }
					}
				},
				--{
		--     PrefabList = { "PREFAB_LIVESTOCK_COW" },
                --     RandomWeight = 1.0,
                --     OffsetSizeRange = {
                --         Min = 0,
                --         Max = 0
                -- },
                --     OrientationRange = {
                --         Min = { 0, -180, 0 },
                --         Max = { 0, 180, 0 }
                -- },
                --     ScaleRange = {
                --         Min = 1.7,
                --         Max = 1.7
                -- },
                --     ColorRange = {
                --         Min = { 0.8,0.8,0.8,1 },
                --         Max = { 1,1,1,1 }
                -- }
            }
        },
        
        {
			DensityMap = "MILK_DENSITY_MAP",
			Density = 0.005,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_LIVESTOCK_COW" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 1.0,
                        Max = 1.0
                },
                    OrientationRange = {
                        Min = { 0, -180, 0 },
                        Max = { 0, 180, 0 }
                },
                    ScaleRange = {
                        Min = 1.3,
                        Max = 1.3
                },
                    ColorRange = {
                        Min = { 0.8,0.8,0.8,1 },
                        Max = { 1,1,1,1 }
                }
            },
				--{
		--     PrefabList = { "PREFAB_LIVESTOCK_SHEEP" },
                --     RandomWeight = 1.0,
                --     OffsetSizeRange = {
                --         Min = 0,
                --         Max = 0
                -- },
                --     OrientationRange = {
                --         Min = { 0, -180, 0 },
                --         Max = { 0, 180, 0 }
                -- },
                --     ScaleRange = {
                --         Min = 1.7,
                --         Max = 1.7
                -- },
                --     ColorRange = {
                --         Min = { 0.8,0.8,0.8,1 },
                --         Max = { 1,1,1,1 }
                -- }
            }
        },
        
        {
			DensityMap = "MILK_DENSITY_MAP",
			Density = 0.005,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_LIVESTOCK_SHEEP" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 1.0,
                        Max = 1.0
                },
                    OrientationRange = {
                        Min = { 0, -180, 0 },
                        Max = { 0, 180, 0 }
                },
                    ScaleRange = {
                        Min = 1.3,
                        Max = 1.3
                },
                    ColorRange = {
                        Min = { 0.8,0.8,0.8,1 },
                        Max = { 1,1,1,1 }
                }
            }
        }
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_BERRIES" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_ROCK" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_FISH" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})
-- This map was created with the help of the UFME


